////****************************************************************************
////  Linux Host Driver for SiI SATA RAID Adapters
////
////  lnxWrapper.h  prototypes
////
//// Copyright (c) 2005  Silicon Image.  All rights reserved.
//// Creator: Vu Le
////
////****************************************************************************

#ifndef _wrapper_LINUX_H
#define _wrapper_LINUX_H

#include <linux/string.h>
#include <sii_ctype.h>
#include <sii_list.h>

// -------------------------------Compile options----------------------------//
/* Need these defines to build all the cores  XXX vuale */

// #define RAID_SUPPORT_EX
#define CONFIG_RAID_SET
#define REBUILD_RATE

#define	CONTAINING_RECORD(a, t, f)	outer(t, f, a)


ULONG asmlinkage RtlCompareMemory(PVOID a, PVOID b, ULONG c);

#define  WriteRegisterUlong(addr, value)   writel((u32)(value), (void *)(addr))
#define  WriteRegisterUshort(addr, value)  writew((u16)(value), (void *)(addr))
#define  WriteRegisterUchar(addr, value)   writeb((u8)  (value), (void *)(addr))
#define  ReadRegisterUlong(addr)           readl( (void *) (addr))
#define  ReadRegisterUshort(addr)          readw( (void *) (addr))
#define  ReadRegisterUchar(addr)           readb( (void *) (addr))

#define SiI_add_timer		  	add_timer
#define SiI_del_timer		  	del_timer
#define SiI_init_timer(a)	  	init_timer(a)

#define	SiI_jiffies                     jiffies
#define SiI_do_gettimeofday		do_gettimeofday
#define SiI_copy_from_user		copy_from_user
#define SiI_copy_to_user		copy_to_user


#define SiI_iounmap			iounmap
#define SiI_ioremap_nocache		ioremap_nocache
#define SiI_pci_map_sg			pci_map_sg
#define SiI_pci_alloc_consistent	pci_alloc_consistent
#define SiI_pci_free_consistent		pci_free_consistent
#define SiI_pci_unmap_single		pci_unmap_single
#define SiI_scsi_to_pci_dma_dir		scsi_to_pci_dma_dir
#define SiI_pci_find_device		pci_find_device
#define SiI_pci_enable_device		pci_enable_device
#define SiI_pci_disable_device		pci_disable_device
#define SiI_pci_set_master		pci_set_master
#define SiI_pci_resource_start		pci_resource_start
#define SiI_pci_resource_len		pci_resource_len
#define SiI_pci_present			pci_present
#define SiI_pci_set_drvdata             pci_set_drvdata
#define SiI_pci_get_drvdata             pci_get_drvdata
#define SiI_pcibios_present		pcibios_present
#define SiI_request_irq			request_irq
#define SiI_free_irq			free_irq
#define SiI_scsi_register_module        scsi_register_module
#define SiI_scsi_unregister_module      scsi_unregister_module
#define SiI_scsi_host_alloc             scsi_host_alloc
#define SiI_scsi_host_put               scsi_host_put
#define SiI_scsi_add_host               scsi_add_host
#define SiI_scsi_remove_host            scsi_remove_host
#define SiI_scsi_register		scsi_register
#define SiI_scsi_unregister		scsi_unregister
#define SiI_scsi_scan_host              scsi_scan_host
#define SiI_scsi_device_lookup          scsi_device_lookup
#define SiI_scsi_add_device             scsi_add_device
#define SiI_scsi_device_cancel          scsi_device_cancel
#define SiI_scsi_remove_device          scsi_remove_device
#define SiI_scsi_device_put             scsi_device_put
#define SiI_scsi_device_set_state       scsi_device_set_state
#define SiI_pci_module_init		pci_module_init
#define SiI_pci_unregister_driver	pci_unregister_driver
#define SiI_pci_request_regions         pci_request_regions
#define SiI_pci_release_regions		pci_release_regions
#define SiI_pci_set_dma_mask		pci_set_dma_mask
#define SiI_pci_read_config_byte	pci_read_config_byte
#define SiI_pci_write_config_byte	pci_write_config_byte
//============================================

//VOID __inline__ 
VOID SiI_pci_unmap_sg (PVOID pcidev, PVOID scatter, USHORT use_sg, INT direction);

//dma_addr_t __inline__
dma_addr_t 
SiI_pci_map_page(
	PVOID pcidev, PVOID dma, INT DataTransferLength, INT DataDirection);
#define SiI_pci_unmap_page    pci_unmap_page

//==============================================

#define RtlFillMemory(p,s,v)   		memset(p,v,s)
#define RtlCopyMemory                   memcpy
#define RtlZeroMemory(a,b)              memset(a,0x0,b)

#define _strnicmp       		strncmp
#define CopyMemory			memcpy
#define ClearMemory(d, l)           	memset(d,0x0,l)
#define CompareMemory 			RtlCompareMemory
#define StallExecution  		sii_usleep

#ifndef ASSERTMSG
#define ASSERTMSG(a,b) {if (!(b)) {sii_panic(a);}}
#endif
//=================================================================

#define HOSTDATA(host)       ((sii_controller_t *)&host->hostdata)

#define PASSIVE_LEVEL           0xFFFF

// Miscellaneous Windows Routines
#define KeGetCurrentIrql()	(PASSIVE_LEVEL - 1)

#endif
