//****************************************************************************
//	Linux Host Driver for SiI SATA RAID Adapters
//
// lnxCommons.h - Include file
//
// Copyright (c) 2005  Silicon Image.  All rights reserved.
// Creator: Vu Le
//
//****************************************************************************
#ifndef _SII_WINSIF
#define _SII_WINSIF

// -------------------------------Compile options----------------------------//
/* Need these defines to build all the cores */
#ifndef _SII_WSCSI
#ifndef BUS_DATA_TYPE
// Define types of bus information.
typedef enum _BUS_DATA_TYPE {
        ConfigurationSpaceUndefined = -1,
        Cmos,
        EisaConfiguration,
        Pos,
	CbusConfiguration,
        PCIConfiguration,
        VMEConfiguration,
        NuBusConfiguration,
        PCMCIAConfiguration,
        MPIConfiguration,
        MPSAConfiguration,
        PNPISAConfiguration,
        SgiInternalConfiguration,
        MaximumBusDataType
} BUS_DATA_TYPE, *PBUS_DATA_TYPE;
#endif 
#endif 

// #define RAID_SUPPORT_EX
#define CONFIG_RAID_SET
#define REBUILD_RATE

#ifdef Si3132                                   // Si 3132
#define MAKE_3132_DRIVER
#include <Supp3132.h>
#elif defined(Si3124)                           // Si 3114
#define MAKE_3124_DRIVER
#include <Supp3124.h>
#elif defined(Si3114)                           // Si 3114
#define MAKE_3114_DRIVER
#include <Supp3114.h>
#else                                           // Si 3112
#define MAKE_3112_DRIVER
#include <Supp3112.h>
#endif

// ------------------------------ Start from here ---------------------------//

#define READ_ATTRIBUTE_BUFFER_SIZE  512

#define READ_ATTRIBUTES			SMART_READ_VALUES
#define READ_THRESHOLDS			SMART_READ_THRESHOLDS
#define ENABLE_DISABLE_AUTOSAVE		SMART_AUTOSAVE
#define SAVE_ATTRIBUTE_VALUES		SMART_SAVE
#define EXECUTE_OFFLINE_DIAGS		SMART_IMMEDIATE_OFFLINE
#define RETURN_SMART_STATUS		SMART_STATUS
#define ENABLE_DISABLE_AUTO_OFFLINE	SMART_AUTO_OFFLINE
#define ENABLE_SMART			SMART_ENABLE
#define DISABLE_SMART			SMART_DISABLE

#if 0
#if RAID_DBG
 #define BASIC_DEBUG_MSG(x)		DebugMsg x ;
 #define        DEBUG_RAID_MSG(x)    	DebugMsg x ;
 #define        DEBUG_RAID_WARN_MSG(x)  DebugMsg x ;
 #define        DEBUG_RAID_ERR_MSG(x)   DebugMsg x ;
 #define 	RAY_DEBUG_MSG(x)	DebugMsg x ;
 #define        KdPrint(x) 		DebugMsg x ;
#else
 #define BASIC_DEBUG_MSG(_x_)
 #define        DEBUG_RAID_MSG(x)
 #define        DEBUG_RAID_WARN_MSG(x)
 #define        DEBUG_RAID_ERR_MSG(x)
 #define 	RAY_DEBUG_MSG(x)
 #define        KdPrint(_x_)
#endif
#endif

#endif // _SII_WINSIF
